import paths.*

// Base cases
countPathsNaive(Coord(-2, -2), Coord(-2, -2), _ => false)
countPathsNaive(Coord(3, 4), Coord(3, 1), _ => false)
countPathsNaive(Coord(3, 4), Coord(0, 4), _ => false)

// Recursion
val obstacles = Set(Coord(1, 1), Coord(3, 4), Coord(3, 2))
countPathsNaive(Coord(0, 0), Coord(4, 5), obstacles.contains)
countPathsNaive(Coord(0, 0), Coord(5, 4), obstacles.contains)
countPathsNaive(Coord(0, 0), Coord(5, 5), obstacles.contains)

// Examples
countPathsNaive(Coord(0, 0), Coord(1, 3), c => false)
countPathsNaive(Coord(0, 0), Coord(1, 3), _ == Coord(1, 0))
